/* Routines to copy/shrink tiles.  copyN(tiles,data,y,p) reads N tiles from
 * data, scales them by a factor of 1:N, and returns the yth scanline of the
 * pth bitplane of the shrunken data as a short. */

short copy16(unsigned short tiles[][128], short *data, short y, short p)
{
    unsigned short d = 0;
    short num = 16;

    while (--num >= 0) {
	d |= (tiles[*data++][p] >> 15) << num;
    }
    return d;
}

short copy8(short tiles[][128], short *data, short y, short p)
{
    unsigned short d = 0, bit = 15;
    unsigned char *d2;
    short num = 8;

    while (--num >= 0) {
	d2 = (unsigned char *)&tiles[*data++][y*8*8+p];
	d |= (*d2++ >> 7) << bit--;
	d |= (*d2++ >> 7) << bit--;
    }
    return d;
}

short copy4(short tiles[][128], short *data, short y, short p)
{
    unsigned short d = 0, bit = 15;
    short num = 4;
    unsigned char *d2, t2;

    while (--num >= 0) {
	d2 = (unsigned char *)&tiles[*data++][y*8*4+p];
	t2 = *d2++;
	d |= (t2 >> 7) << bit--;
	d |= ((t2 >> 3) & 1) << bit--;
	t2 = *d2++;
	d |= (t2 >> 7) << bit--;
	d |= ((t2 >> 3) & 1) << bit--;
    }
    return d;
}

short copy2(short tiles[][128], short *data, short y, short p)
{
    unsigned short d = 0, bit = 15;
    unsigned char *d2, t2;

    d2 = (unsigned char *)&tiles[*data++][y*8*2+p];
    t2 = *d2++;
    d |= (t2 >> 7) << bit--;
    d |= ((t2 >> 5) & 1) << bit--;
    d |= ((t2 >> 3) & 1) << bit--;
    d |= ((t2 >> 1) & 1) << bit--;
    t2 = *d2++;
    d |= (t2 >> 7) << bit--;
    d |= ((t2 >> 5) & 1) << bit--;
    d |= ((t2 >> 3) & 1) << bit--;
    d |= ((t2 >> 1) & 1) << bit--;

    d2 = (unsigned char *)&tiles[*data][y*8*2+p];
    t2 = *d2++;
    d |= (t2 >> 7) << bit--;
    d |= ((t2 >> 5) & 1) << bit--;
    d |= ((t2 >> 3) & 1) << bit--;
    d |= ((t2 >> 1) & 1) << bit--;
    t2 = *d2++;
    d |= (t2 >> 7) << bit--;
    d |= ((t2 >> 5) & 1) << bit--;
    d |= ((t2 >> 3) & 1) << bit--;
    d |= ((t2 >> 1) & 1) << bit--;

    return d;
}
