/* Routines to copy/shrink tiles.  copyN(tiles,data,y,p) reads a tile from
 * data, scales it by a factor of 1:N, and writes its yth scanline to dest.
 */

#include "tile.h"
extern short planes;

void copy16(unsigned short tiles[][128], short *data, short y, pixel *dest)
{
    short i = planes;
    unsigned char d = 0;
    unsigned short *s = &tiles[*data][y*8+planes];

    while (--i >= 0) {
	d |= (*--s >> 15) << i;
    }
    *dest = d;
}

void copy8(unsigned short tiles[][128], short *data, short y, pixel *dest)
{
    short i = planes;
    unsigned short d;
    short *s = &tiles[*data][y*8+planes];

    dest[0] = dest[1] = 0;
    while (--i >= 0) {
	d = *--s;
	dest[0] |= (d>>15) << i;
	dest[1] |= ((d>>7)&1) << i;
    }
}

void copy4(unsigned short tiles[][128], short *data, short y, pixel *dest)
{
    short i = planes;
    unsigned short d;
    short *s = &tiles[*data][y*8+planes];

    bzero(dest, 4*sizeof(pixel));
    while (--i >= 0) {
	d = *--s;
	dest[0] |= (d>>15) << i;
	dest[1] |= ((d>>11)&1) << i;
	dest[2] |= ((d>>7)&1) << i;
	dest[3] |= ((d>>3)&1) << i;
    }
}

void copy2(unsigned short tiles[][128], short *data, short y, pixel *dest)
{
    short i = planes;
    unsigned short d;
    short *s = &tiles[*data][y*8+planes];

    bzero(dest, 8*sizeof(pixel));
    while (--i >= 0) {
	d = *--s;
	dest[0] |= (d>>15) << i;
	dest[1] |= ((d>>13)&1) << i;
	dest[2] |= ((d>>11)&1) << i;
	dest[3] |= ((d>>9)&1) << i;
	dest[4] |= ((d>>7)&1) << i;
	dest[5] |= ((d>>5)&1) << i;
	dest[6] |= ((d>>3)&1) << i;
	dest[7] |= ((d>>1)&1) << i;
    }
}

void copy1(unsigned short tiles[][128], short *data, short y, pixel *dest)
{
    short i = planes, j;
    unsigned short d;
    short *s = &tiles[*data][y*8+planes];

    bzero(dest, 16*sizeof(pixel));
    while (--i >= 0) {
	d = *--s;
	for (j = 0; j < 16; ++j)
	    dest[j] |= ((d >> (j^15)) & 1) << i;
    }
}
